package com.unitedcoders.examples.spring.oxm;

import java.io.IOException;

import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.unitedcoders.examples.spring.oxm.beans.Person;
import com.unitedcoders.examples.spring.oxm.mapper.OxMapper;

public class ExampleApp {

    /**
     * @param args
     */
    public static void main(String[] args) throws IOException {
        ClassPathXmlApplicationContext context = new ClassPathXmlApplicationContext(
                "example-context.xml");
        OxMapper oxMapper = (OxMapper) context.getBean("oxMapper");

        Person person = new Person();
        person.setFirstname("Phil");
        person.setLastname("Steffensen");
        person.setDeveloper(true);
        
        Person friend1 = new Person();
        friend1.setFirstname("Christian");
        friend1.setLastname("Harms");
        friend1.setDeveloper(true);
        
        person.addFriend(friend1);

        Person friend2 = new Person();
        friend2.setFirstname("John");
        friend2.setLastname("Doe");
        friend2.setDeveloper(false);
        
        person.addFriend(friend2);

        String filename = "person_with_friends.xml";
        oxMapper.writeObjectToXml(person, filename);

        Person deserializedPerson = (Person) oxMapper.readObjectFromXml(filename);

        System.out.println("Firstname: " + deserializedPerson.getFirstname());
        System.out.println("Lastname : " + deserializedPerson.getLastname());
        System.out.println("Developer: " + deserializedPerson.isDeveloper());
        System.out.println("Friends  : " + deserializedPerson.getFriends().size());
    }

}
